
%define apuver 0

Summary: Apache Portable Runtime Utility library
Name: apr-util
Version: 0.9.4
Release: 22%{?dist}.1
License: Apache Software License
Group: System Environment/Libraries
URL: http://apr.apache.org/
Source0: %{name}-%{version}.tar.gz
Patch0: apr-util-0.9.3-deplibs.patch
Patch1: apr-util-0.9.3-config.patch
Patch2: apr-util-0.9.4-db4.patch
Patch3: apr-util-0.9.4-gcc34.patch
Patch4: apr-util-0.9.4-sdbm.patch
Patch5: apr-util-0.9.4-sdbmnames.patch
Patch6: apr-util-0.9.4-xlate.patch
Patch7: apr-util-0.9.4-shapass.patch
Patch9: apr-util-0.9.4-filebucket.patch
Patch10: apr-util-0.9.4-rmm.patch
Patch11: apr-util-1.2.7-xmlnspace.patch
# Security fixes
Patch8: apr-util-0.9.4-CAN-2004-0786.patch
Patch20: apr-util-1.2.7-CVE-2009-0023.patch
Patch21: apr-util-1.2.7-CVE-2009-1955.patch
Patch22: apr-util-1.2.7-CVE-2009-1956.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildPrereq: autoconf, libtool, doxygen, apr-devel >= 0:0.9.4-1
BuildPrereq: openldap-devel, db4-devel, expat-devel
Conflicts: subversion < 0.20.1-2

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines.  This library
contains additional utility interfaces for APR; including support
for XML, LDAP, database interfaces, URI parsing and more.

%package devel
Group: Development/Libraries
Summary: APR utility library development kit
Requires: apr-util = %{version}-%{release}, apr-devel
Requires: openldap-devel, db4-devel, expat-devel
Conflicts: subversion-devel < 0.20.1-2

%description devel
This package provides the support files which can be used to 
build applications using the APR utility library.  The mission 
of the Apache Portable Runtime (APR) is to provide a free 
library of C data structures and routines.

%prep
%setup -q
%patch0 -p1 -b .deplibs
%patch1 -p1 -b .config
%patch2 -p1 -b .db4
%patch3 -p1 -b .gcc34
%patch4 -p1 -b .sdbm
%patch5 -p1 -b .sdbmnames
%patch6 -p1 -b .xlate
%patch7 -p1 -b .shapass
%patch8 -p1 -b .can0786
%patch9 -p1 -b .filebucket
%patch10 -p1 -b .rmm
%patch11 -p1 -b .xmlnspace

%patch20 -p1 -b .cve0023
%patch21 -p1 -b .cve1955
%patch22 -p1 -b .cve1956

rm -rf autom4te*.cache

%build
autoheader && autoconf
%configure --with-apr=%{_prefix} \
        --includedir=%{_includedir}/apr-%{apuver} \
        --with-ldap --without-gdbm
make %{?_smp_mflags} && make dox

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# Documentation
mv docs/dox/html html

# Unpackaged files
rm -f $RPM_BUILD_ROOT%{_libdir}/aprutil.exp

%check
# Run the less verbose tests
%define tests testmd5 testrmm teststrmatch testuri testxlate
cd test; make %{?_smp_mflags} %{tests} testdbm
for t in %{tests}; do ./${t} || exit 1; done
./testdbm auto tsdbm
./testdbm -tDB auto tbdb.db

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE
%{_libdir}/libaprutil-%{apuver}.so.*

%files devel
%defattr(-,root,root,-)
%{_bindir}/apu-config
%{_libdir}/libaprutil-%{apuver}.*a
%{_libdir}/libaprutil-%{apuver}.so
%{_includedir}/apr-%{apuver}/*.h
%doc --parents html

%changelog
* Mon Jun  8 2009 Joe Orton <jorton@redhat.com> 0.9.4-22.el4_8.1
- add security fixes for CVE-2009-0023, CVE-2009-1955, 
  and CVE-2009-1956 (#504558)

* Tue Jan  8 2008 Joe Orton <jorton@redhat.com> 0.9.4-22.el4
- apr_xml: fix XML attribute namespace handling (#234854)

* Thu Jun 16 2005 Joe Orton <jorton@redhat.com> 0.9.4-21
- add apr_rmm_* fixes from upstream (#160034)

* Thu Jun  2 2005 Joe Orton <jorton@redhat.com> 0.9.4-20
- add FILE bucket fix for truncated files (#159191)

* Fri Sep 17 2004 Joe Orton <jorton@redhat.com> 0.9.4-17
- add security fix for CAN-2004-0786

* Sat Jun 19 2004 Joe Orton <jorton@redhat.com> 0.9.4-16
- have -devel require matching release of apr-util

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Apr  1 2004 Joe Orton <jorton@redhat.com> 0.9.4-14
- fix use of SHA1 passwords (#119651)

* Tue Mar 30 2004 Joe Orton <jorton@redhat.com> 0.9.4-13
- remove fundamentally broken check_sbcs() from xlate code

* Fri Mar 19 2004 Joe Orton <jorton@redhat.com> 0.9.4-12
- tweak xlate fix

* Fri Mar 19 2004 Joe Orton <jorton@redhat.com> 0.9.4-11
- rebuild with xlate fixes and tests enabled

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com> 0.9.4-10.1
- rebuilt

* Tue Mar  2 2004 Joe Orton <jorton@redhat.com> 0.9.4-10
- rename sdbm_* symbols to apu__sdbm_*

* Mon Feb 16 2004 Joe Orton <jorton@redhat.com> 0.9.4-9
- fix sdbm apr_dbm_exists() on s390x/ppc64

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com> 0.9.4-8
- rebuilt

* Thu Feb  5 2004 Joe Orton <jorton@redhat.com> 0.9.4-7
- fix warnings from use of apr_optional*.h with gcc 3.4

* Thu Jan 29 2004 Joe Orton <jorton@redhat.com> 0.9.4-6
- drop gdbm support

* Thu Jan  8 2004 Joe Orton <jorton@redhat.com> 0.9.4-5
- fix DB library detection

* Sat Dec 13 2003 Jeff Johnson <jbj@jbj.org> 0.9.4-4
- rebuild against db-4.2.52.

* Mon Oct 13 2003 Jeff Johnson <jbj@jbj.org> 0.9.4-3
- rebuild against db-4.2.42.

* Mon Oct  6 2003 Joe Orton <jorton@redhat.com> 0.9.4-2
- fix 'apu-config --apu-la-file' output

* Mon Oct  6 2003 Joe Orton <jorton@redhat.com> 0.9.4-1
- update to 0.9.4.

* Tue Jul 22 2003 Nalin Dahyabhai <nalin@redhat.com> 0.9.3-10
- rebuild

* Mon Jul  7 2003 Joe Orton <jorton@redhat.com> 0.9.3-9
- rebuild
- don't run testuuid test because of #98677

* Thu Jul  3 2003 Joe Orton <jorton@redhat.com> 0.9.3-8
- rebuild

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue May 20 2003 Joe Orton <jorton@redhat.com> 0.9.3-6
- fix to detect crypt_r correctly (CAN-2003-0195)

* Thu May 15 2003 Joe Orton <jorton@redhat.com> 0.9.3-5
- fix to try linking against -ldb first (#90917)
- depend on openldap, gdbm, db4, expat appropriately.

* Tue May 13 2003 Joe Orton <jorton@redhat.com> 0.9.3-4
- rebuild

* Wed May  7 2003 Joe Orton <jorton@redhat.com> 0.9.3-3
- make devel package conflict with old subversion-devel
- run the less crufty parts of the test suite

* Tue Apr 29 2003 Joe Orton <jorton@redhat.com> 0.9.3-2
- run ldconfig in post/postun

* Mon Apr 28 2003 Joe Orton <jorton@redhat.com> 0.9.3-1
- initial build
